#!/usr/bin/perl

use strict;
use Getopt::Std;
use nde;

my %opts;
getopts( 'vhoeu:t:', \%opts );
if ( $opts{ 'h' } || ! $ARGV[0] ) { usage(); }

my $debug;
if( $opts{ 'v' } ) { $debug = "YES" ; }

my $timeout = $opts{ 't'};

my $username;
if ( $opts{ 'u' } )
{
	$username = $opts{ 'u' };
}
else
{
	$username = `/usr/bin/whoami`;
	chomp($username); # don't forget this!
}

my $passwd;
if ( ! $opts{ 'o' } )
{
	$passwd = nde::get_password();
}

my $enablepasswd;
if( $opts{ 'e' } )
{
	$enablepasswd = nde::get_password("Enable Password: ");
}

foreach my $device (@ARGV)
{
	if ( $opts{ 'o' } )
	{
		$passwd = nde::get_password( "", "echo" );
	}
	my $rh = nde::create_session( "", $device, $username, $passwd, $debug, $timeout, $enablepasswd  );
	nde::login();
	nde::get_type();
	nde::logout();
	printf "%-16s -> %-7s -> %-8s -> %-s\n", $device ,$$rh{ 'method' } , $$rh{'type'}, $$rh{'version'};
}
exit 0;


sub usage
{
	print "usage: $0 [-hvoe] [-u username] [-t timeout] device ...\n";
	print "connects to the listed device(s),\n";
	print "and reports on the device type and software version.\n";
        print "\n";
	print "options:\n";
	print "-h  =  print this message\n";
	print "-v  =  view interactive sessions as they happen\n";
	print "-o  =  prompt for a new password before connecting to each device (one time passwords)\n";
	print "-e  =  prompt for and use an enable password\n";
	print "-u username = use username when logging onto device(s), default is to use output of whoami\n";
	print "-t timeout = wait timeout seconds for responses from device(s), default is to wait 60 seonds\n";
	
	exit 1;
}

sub usage
{
	print "usage: $0 [-hve] [-u username] [-t timeout] device ...\n";
	print "connects to the listed device(s),\n";
	print "and reports on the device type and software version.\n";
        print "\n";
	print "options:\n";
	print "-h  =  print this message\n";
	print "-v  =  view interactive sessions as they happen\n";
	print "-e  =  prompt for and use an enable password\n";
	print "-u username = use username when logging onto device(s), default is to use output of whoami\n";
	print "-t timeout = wait timeout seconds for responses from device(s), default is to wait 60 seonds\n";
	
	exit 1;
}
